
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class HighlightsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const highlights = await db.highlights.create(
            {
                id: data.id || undefined,
        
        title: data.title
        ||
        null
            ,
            
        is_archived: data.is_archived
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await highlights.setOwner( data.owner || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.highlights.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: highlights.id,
            },
            data.cover_image,
            options,
        );
        

        return highlights;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const highlightsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                title: item.title
            ||
            null
            ,
            
                is_archived: item.is_archived
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const highlights = await db.highlights.bulkCreate(highlightsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < highlights.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.highlights.getTableName(),
                    belongsToColumn: 'cover_image',
                    belongsToId: highlights[i].id,
                },
                data[i].cover_image,
                options,
            );
        }
        

        return highlights;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const highlights = await db.highlights.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.is_archived !== undefined) updatePayload.is_archived = data.is_archived;
        
        
        updatePayload.updatedById = currentUser.id;

        await highlights.update(updatePayload, {transaction});

        
        
        if (data.owner !== undefined) {
            await highlights.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.highlights.getTableName(),
                belongsToColumn: 'cover_image',
                belongsToId: highlights.id,
            },
            data.cover_image,
            options,
        );
        

        return highlights;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const highlights = await db.highlights.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of highlights) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of highlights) {
                await record.destroy({transaction});
            }
        });


        return highlights;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const highlights = await db.highlights.findByPk(id, options);

        await highlights.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await highlights.destroy({
            transaction
        });

        return highlights;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const highlights = await db.highlights.findOne(
            { where },
            { transaction },
        );

        if (!highlights) {
            return highlights;
        }

        const output = highlights.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.highlight_items_highlight = await highlights.getHighlight_items_highlight({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.owner = await highlights.getOwner({
            transaction
        });
        
        
        output.cover_image = await highlights.getCover_image({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'cover_image',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'highlights',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_archived) {
                where = {
                    ...where,
                is_archived: filter.is_archived,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.highlights.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'highlights',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.highlights.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

